#ifndef __SETTINGS_H
#define __SETTINGS_H
//------------------------------------------------------------------------------
#define  F_CPU 1000000L
#define  _delay_ms(ms) 	__delay_cycles((F_CPU / 1000) * (ms));
#define  _delay_us(us) 	__delay_cycles((F_CPU / 1000000) * (us));
//------------------------------------------------------------------------------
#define ON          1
#define OFF         0
#define UP          1
#define DOWN        0
//------------------------------------------------------------------------------
//  
#define KEY_UP      1         //    (+)
#define KEY_DOWN    2         //     (-)
#define PUSH_MIN    5         // x10 = 50 
#define PUSH_SHORT  50        // x10 = 500 
#define PUSH_LONG   200       // x10 = 2 
//------------------------------------------------------------------------------
#define TIME_BEFOR_RESET_INPUT_CODE 200       // x10 (2 )       
#define TIME_BEFOR_AUTO_OFF         360000L   // x10 (1 )     
#define SEND_RDS_PERIOD             50        // x10 (500 )     RDS ( 4 )
//------------------------------------------------------------------------------
#define MIN_WORK_FREQ       88000     //    
#define MAX_WORK_FREQ       108000    //    
#define DEFAULT_WORK_FREQ   95000     //     
#define STEP_WORK_FREQ      100       //     (50/100)
#define DEFAULT_FDEV        20        //     *10
#define DEFAULT_MIC_GAIN    5         //     
#define MAX_CHANNELS        30        //   ( 120  ATTINY45  248  ATTINY85 )
//------------------------------------------------------------------------------
//  RDS
#define RDS_PI_H            0x70      // PI 
#define RDS_PI_L            0xFF
#define RDS_GROUP           0x00      // A3 A2 A1 A0  B0 TP  0  0
#define RDS_PTY             30
#define RDS_DEV             6         // RDS [6:0] frequency deviation = 0.35KHz*RDSFDEV. 
#define RDS_DEF_STR         "RadioMic"//  RDS  
//------------------------------------------------------------------------------
//  QN8027.
#define TC                  0         // 0 - 50us / 1 - 75us, pre_emph_time
#define MONO                1         // 0 -  / 1 - 
#define GAIN_TXPLT          7         // (7...10)*75kHz    
#define XISEL               16        // (0...64)  Crystal oscillator current control  6.25uA*XISEL[5:0], 0-400uA 
#define XSEL                0         // 0 - 12 / 1 - 24 
#define POWER               75        // (20 ... 75)  
#define QNDELAY             100       //   QN8027 []
//------------------------------------------------------------------------------
//  :
#define MIN_QN8027_CH       (MIN_WORK_FREQ - 76000)/50
#define MAX_QN8027_CH       (MAX_WORK_FREQ - 76000)/50
#define DEF_QN8027_CH       (DEFAULT_WORK_FREQ - 76000)/50
#define STEP_CH             STEP_WORK_FREQ / 50
//------------------------------------------------------------------------------     
#define AGC_MAX_VALUE       13        // 0...15    
#endif //__SETTINGS_H


