/*------------------------------------------------------------------------------
  ().........:   igor727@mail.ru
  ..: 
  .......:
  .........: 
  .............:
------------------------------------------------------------------------------*/
#include <ioavr.h>
#include <intrinsics.h>
#include "Sound.h"
#include "Settings.h"

//==============================================================================
//================================ PlayTone ====================================
//==============================================================================
void PlayTone (unsigned char tone, unsigned int time_ms, unsigned int delay_ms)
{ OCR0A = tone;
  TCCR0A = (1<<COM0A0)|(1<<WGM01);
  TCCR0B = (1<<CS01); //   =8.   1    125.
//    = 125000 /(2*tone) = 62500/tone [].
  for (unsigned int i = 0; i<time_ms; i++)
  { _delay_ms (1);
    __watchdog_reset ();
  }
  TCCR0A = 0;
  TCCR0B = 0;
  PORTB &= ~(1<<PB0);
  for (unsigned int i = 0; i<delay_ms; i++)
  { _delay_ms (1);
    __watchdog_reset ();
  }
}

//==============================================================================
//============================== PlaySoundOn ================================
//==============================================================================
void PlaySoundOn (void)
{ //     -  - 
  PlayTone(79,200,0);        
  PlayTone(63,200,0); 
  PlayTone(53,100,0); 
}

//==============================================================================
//============================== PlaySoundOff ================================
//==============================================================================
void PlaySoundOff (void)
{ //     -  - 
  PlayTone(59,200,0);        
  PlayTone(63,200,0); 
  PlayTone(79,100,0); 
}


//==============================================================================
//============================== PlaySoundInput ================================
//==============================================================================
void PlaySoundInput (void)
{ //      - 
  PlayTone(79,200,50); 
  PlayTone(59,100,0);
}

//==============================================================================
//============================== PlaySoundOutput ===============================
//==============================================================================
void PlaySoundOutput (void)
{ //       - 
  PlayTone(59,200,50);
  PlayTone(79,100,0); 
}

//==============================================================================
//============================== PlaySoundError ================================
//==============================================================================
void PlaySoundError (void)
{ //     -  -  - 
  PlayTone(142,100,50); 
  PlayTone(142,100,50);
  PlayTone(142,100,50);
  PlayTone(179,400,0); 
}
//==============================================================================
//============================== PlaySoundClear ================================
//==============================================================================
void PlaySoundClear (void)
{ //   
  for (unsigned char i=64; i>32; i--)
  { PlayTone(i,20,0);}  
}

//==============================================================================
//============================== PlaySoundOverUp ================================
//==============================================================================
void PlaySoundUp (void)
{ //   
  PlayTone(56,100,0);
}

//==============================================================================
//============================== PlaySoundOverDown ================================
//==============================================================================
void PlaySoundDown (void)
{ //   
  PlayTone(69,100,0);              //   
}


//==============================================================================
//============================== PlaySoundUp ===================================
//==============================================================================
void PlaySoundOverUp (void)
{ //    
  for (unsigned char i=0; i<10; i++)
  { PlayTone(56,20,1);}
}

//==============================================================================
//============================== PlaySoundDown =================================
//==============================================================================
void PlaySoundOverDown (void)
{ //    
  for (unsigned char i=0; i<10; i++)
  { PlayTone(69,20,1);}
}





