/*==============================================================================
  ().........:   igor727@mail.ru
  ..: ATTINY 85
  .......: IAR Assembler for AVR 5.30.0 (5.30.0.50166)
  .........:  c    RDS ( QN8027)
  .............: 
//============================================================================*/
#include <ioavr.h>
#include <intrinsics.h>
#include "QN8027.h"
#include "eeprom.h"
#include "Sound.h"
#include "Sys.h"
#include "Settings.h"
//==============================================================================
//     
const unsigned char   CODE_SET_FREQ[10]     = {KEY_DOWN,  KEY_DOWN, KEY_DOWN, KEY_UP,   KEY_DOWN, KEY_UP,   KEY_UP,   KEY_UP,   0,        0};
const unsigned char   CODE_SET_CH[10]       = {KEY_DOWN,  KEY_DOWN, KEY_UP,   KEY_DOWN, KEY_UP,   KEY_UP,   0,        0,        0,        0};
const unsigned char   CODE_RESET_ALL[10]    = {KEY_DOWN,  KEY_DOWN, KEY_DOWN, KEY_DOWN, KEY_UP,   KEY_UP,   KEY_UP,   KEY_DOWN, KEY_DOWN, KEY_UP};
const unsigned char   CODE_SET_MIC_GAIN[10] = {KEY_DOWN,  KEY_DOWN, KEY_DOWN, KEY_UP,   KEY_DOWN, KEY_DOWN, KEY_UP,   KEY_DOWN, KEY_DOWN, KEY_DOWN};
const unsigned char   CODE_DELET_CH[10]     = {KEY_DOWN,  KEY_DOWN, KEY_UP,   KEY_UP,   KEY_DOWN, KEY_DOWN, KEY_UP,   KEY_UP,   KEY_UP,   KEY_UP};
const unsigned char   CODE_TURN_FDEV[10]    = {KEY_DOWN,  KEY_DOWN, KEY_DOWN, KEY_UP,   KEY_UP,   KEY_DOWN, KEY_UP,   KEY_DOWN, KEY_DOWN, KEY_UP};
const unsigned char   CODE_ON_OFF_RDS[10]   = {KEY_DOWN,  KEY_UP,   KEY_UP,   KEY_UP,   KEY_UP,   KEY_UP,   KEY_UP,   KEY_UP,   KEY_UP,   KEY_UP};
const unsigned char   CODE_ON_OFF_AGC[10]   = {KEY_UP,    KEY_UP,   KEY_UP,   KEY_UP,   KEY_DOWN, KEY_DOWN, KEY_UP,   KEY_UP,   KEY_UP,   KEY_UP};
//==============================================================================
extern unsigned char  CurrentState, Event;                        //    .
extern unsigned int   FreqCh;                                     //   QN8027.      f[] = (FreqCH * 50 + 76000) 
extern unsigned char  FDev;                                       //  
unsigned char         MicGain;                                    //  
unsigned char         Mute;                                       //    
unsigned int          CntButtonDown, CntButtonUp;                 //              
unsigned long int     TimeOut;                                    //       
unsigned char         LedCnt;                                     //    
unsigned char         InputCode [10];                             //         
unsigned char         CntCode;                                    //   
unsigned char         WorkChannel;                                //    (EEPROM)
unsigned char         RDS_Time_Counter;                           //       RDS
extern unsigned char  RDS_Enable;                                 //   RDS
const unsigned char   RDS_STRING_DEFAULT [] = RDS_DEF_STR;        // RDS   .
unsigned char         UnLock;                                     // 0-   , 1-    . 
extern unsigned char  AGCEnable;                                  //  1- , 0- 
extern unsigned char  AGCMicGain;                                 //    
//==============================================================================
//=============================== CheckButtons =================================
//==============================================================================
void CheckButtons (void)
{//   
  if ((PINB & (1<<PB4))!=0)
  { //  
    TimeOut=0;                                                    //      
    if (CntButtonUp < PUSH_LONG ) CntButtonUp++;                  //       PUSH_LONG
    if (CntButtonUp == PUSH_LONG)
    { //            
      if (CntButtonDown == 0)         Event = EVENT_KEY_UP_LONG;  //              
      if (CntButtonDown >= PUSH_LONG) Event = EVENT_TWO_KEY_LONG; //               
      CntButtonUp = PUSH_LONG+1;                                  //    
    }
  }
  else
  { //    
    if (CntButtonUp)  
    { //     .    
      if ((CntButtonUp >= PUSH_MIN) && (CntButtonUp <= PUSH_SHORT) && (CntButtonDown==0)) Event = EVENT_KEY_UP_SHORT; //      
    }
    CntButtonUp = 0;
  }
//    
  if ((PINB & (1<<PB3))!=0)
  { //  
    TimeOut=0;                                                      //      
    if (CntButtonDown < PUSH_LONG ) CntButtonDown++;                //       PUSH_LONG
    if (CntButtonDown == PUSH_LONG)
    { //            
      if (CntButtonUp == 0)          Event = EVENT_KEY_DOWN_LONG;   //            
      if (CntButtonUp >= PUSH_LONG)  Event = EVENT_TWO_KEY_LONG;    //               
      CntButtonDown = PUSH_LONG+1;                                  //    
    }
  }
  else
  { //    
    if (CntButtonDown)  
    { //     .    
      if ((CntButtonDown >= PUSH_MIN) && (CntButtonDown <= PUSH_SHORT) && (CntButtonUp==0)) Event = EVENT_KEY_DOWN_SHORT; //      
    }
    CntButtonDown = 0;
  }
}

//==============================================================================
//================================= CountTime ==================================
//==============================================================================
void CountTime (void)
{  //  
  switch (CurrentState)
  { 
    case  STATE_MUTE:               //   STATE_MUTE 
      //      -      
      LedCnt++;
      if (LedCnt == 50)       
      { PORTB &= ~(1<<PB0);}        //   500   .
      else if (LedCnt >= 100) 
      { PORTB |= 1<<PB0;            //   1000      
        LedCnt=0;
      }
    case  STATE_POWER_ON:           //   STATE_POWER_ON   
    case  STATE_FREQ_SET:           //   STATE_FREQ_SET 
    case  STATE_CHANNEL_SET:        //   STATE_CHANNEL_SET 
    case  STATE_MIC_GAIN_SET:       //   STATE_MIC_GAIN_SET 
    case  STATE_TURN_DEVIATION:     //   STATE_TURN_DEVIATION
      //    
      if (TimeOut < TIME_BEFOR_AUTO_OFF)  TimeOut++; 
      if (TimeOut == TIME_BEFOR_AUTO_OFF)  
      { TimeOut = TIME_BEFOR_AUTO_OFF + 1;  //    
        Event = EVENT_AUTO_OFF;     //  .
      } 
      //
      if (TimeOut == TIME_BEFOR_RESET_INPUT_CODE) ClearCode(); //    

      //   RDS ,       
      if (RDS_Enable)
      { RDS_Time_Counter++;
        if (RDS_Time_Counter >=SEND_RDS_PERIOD)
        { RDS_Time_Counter = 0;
          QN8027_SendRDSBlock ();   //   RDS
        }  
      }
      break;
  }
}
    

//==============================================================================
//================================ PowerOff ====================================
//==============================================================================
void PowerOff (void)
{ ClearCode();
  QN8027_MuteOff ();              //  
  PlaySoundOff ();                //   
  CurrentState = STATE_POWER_OFF; //    
  PORTB |= (1<<PB5);              // .  
}

//==============================================================================
//================================ PowerOn =====================================
//==============================================================================
void PowerOn (void)
{ unsigned char tmp8;
  //     
  PORTB &= ~(1<<PB5);                     //   (  )
  //         (   )   EEPROM (   )?
  if (CountChannels())
  {//   .   ,     .
    WorkChannel = EEPROM_Read (0x0F);     //    (  )
    //      
    if (CheckChannelValue (WorkChannel))
    {//  .    .
      FreqCh = ReadChannel(WorkChannel);
    }
    else
    { //   .   . 
      //          . 
      //       .              
      FreqCh = DEF_QN8027_CH;             //    QN8027  .
      tmp8 = FindChannelByFreqCh (DEF_QN8027_CH); //      
      if (tmp8)                
      { //         .        .
        WorkChannel = tmp8;               //        
        EEPROM_Write (0x0F, WorkChannel); //        
      }
      else
      {//      .         .
        WriteChannel(WorkChannel,DEF_QN8027_CH);
      }
    }
  }
  else
  {//   .    .
    ClearAllChannel();
  }     
//------------------------------------------------------------------------------   
  //        
  MicGain = AGCMicGain = EEPROM_Read(0x09);
  FDev = EEPROM_Read(0x0A); 
  if ((MicGain > 13) || (FDev > 25))
  {//        .   EEPROM        
    MicGain = AGCMicGain= DEFAULT_MIC_GAIN;
    EEPROM_Write(0x09, MicGain);
    //       
    FDev = DEFAULT_FDEV;     
    EEPROM_Write(0x0A, FDev);
  }
//------------------------------------------------------------------------------  
  //    RDS            
  RDS_Enable = EEPROM_Read(0x08);
  if (RDS_Enable>1)
  { RDS_Enable =1;
    EEPROM_Write(0x08,RDS_Enable );
  }
  CheckAndCorectRDSString ();   //   RDS        RDS_DEF_STR
//------------------------------------------------------------------------------  
  //                
  AGCEnable = EEPROM_Read(0x0B);
  if (AGCEnable > 1)
  { //   
    AGCEnable = 1; //    
    EEPROM_Write(0x0B,RDS_Enable );
  }  
//------------------------------------------------------------------------------
  //  QN8027
  i2c_init();                     //  I2C
  QN8027_Init();                  //  QN8027
  PlaySoundOn ();                 //   .
  CurrentState = STATE_POWER_ON;  //    
  ClearCode();
}

//==============================================================================
//============================== MicSoundOff ===================================
//==============================================================================
void MicSoundOff (void)
{ //   
  PlaySoundOutput ();             //   
  QN8027_MuteOn ();               //  
  ClearCode();                    //    
  CurrentState = STATE_MUTE;      //      
}

//==============================================================================
//============================== MicSoundOn ====================================
//==============================================================================
void MicSoundOn (void)
{ //   
  QN8027_MuteOff ();         
  PlaySoundInput (); 
  ClearCode();
  CurrentState = STATE_POWER_ON;  //    
}

//==============================================================================
//============================== StepUpMicGain =================================
//==============================================================================
void StepUpMicGain (void)
{ //    ()
  if (MicGain < 13)
  { MicGain ++;
    QN8027_SetMicGain (MicGain);  //   QN8027  
    PlaySoundUp ();               //     
  }
  else     PlaySoundOverUp ();    //    
  AGCMicGain = MicGain;
}

//==============================================================================
//============================== StepDownMicGain ===============================
//==============================================================================
void StepDownMicGain (void)
{ //    ()
  if (MicGain > 0)
  { MicGain --;
    QN8027_SetMicGain (MicGain);  //   QN8027  
    PlaySoundDown ();             //     
  }
  else PlaySoundOverDown ();      //    
  AGCMicGain = MicGain;
}

//==============================================================================
//============================== SaveMicGain ===================================
//==============================================================================
void SaveMicGain(void)
{ //    
  EEPROM_Write(0x09, MicGain);    //     
  AGCMicGain=MicGain;
  PlaySoundInput();               //   
  CurrentState = STATE_POWER_ON;  //    
}
   
//==============================================================================
//============================== NoSaveMicGain ===================================
//==============================================================================
void NoSaveMicGain(void)
{ //     
  MicGain =  AGCMicGain = EEPROM_Read(0x09);    //     
  QN8027_SetMicGain (MicGain);           //   QN8027  
  PlaySoundOutput();              //   
  CurrentState = STATE_POWER_ON;  //    
}



//==============================================================================
//============================== StepUpFreq ====================================
//==============================================================================
void StepUpFreq(void)
{ //    1  
  if ( FreqCh >= MAX_QN8027_CH)  
  { //      
    FreqCh = MAX_QN8027_CH;
    PlaySoundOverUp ();           //    
  }
  else  
  { //    .    1 .
    FreqCh += STEP_CH;
    //      .   .
    if ( FreqCh > MAX_QN8027_CH)  FreqCh = MAX_QN8027_CH;
    QN8027_SetFreqCh ();          //      QN8027
    PlaySoundUp ();               //     
  }
}



//==============================================================================
//============================= StepDownFreq ===================================
//==============================================================================
void StepDownFreq(void)
{ //    1  
  if ( FreqCh <= MIN_QN8027_CH) 
  {//      
    FreqCh = MIN_QN8027_CH;
    PlaySoundOverDown ();         //    
  }
  else
  { //    .    1 .
    FreqCh -= STEP_CH;
    //      .   .
    if ( FreqCh < MIN_QN8027_CH)  FreqCh = MIN_QN8027_CH;
    QN8027_SetFreqCh();
    PlaySoundDown ();             //     
  }
}

//==============================================================================
//============================= SaveFreqToMem ==================================
//==============================================================================
void SaveFreqToMem(void)
{ unsigned char tmp8;
  //         
  //       ?
  if (CountFreeChannels())
  { //     
    //         ?
    tmp8 = FindChannelByFreqCh(FreqCh);         
    if (tmp8 == 0)
    { //     .       
      WorkChannel = FindFreeChannel (); //     
      WriteChannel (WorkChannel,FreqCh);//     
      EEPROM_Write(0x0F, WorkChannel);  //      WorkChannel 
    }
    else
    {//      .   .     
      WorkChannel = tmp8;
      EEPROM_Write(0x0F, WorkChannel);  //      WorkChannel
    }
    PlaySoundInput();                   //   
    CurrentState=STATE_POWER_ON;
  }
  else PlaySoundError();//  .   .    
}

//==============================================================================
//============================= NoChangeFreqOrCh ===============================
//==============================================================================
void NoChangeFreqOrCh(void)
{ //             ?
  WorkChannel = EEPROM_Read(0x0F);      //      .
  if ( FreqCh != ReadChannel (WorkChannel))
  { PlaySoundOutput();                  //   
    FreqCh = ReadChannel (WorkChannel); //       
    QN8027_SetFreqCh ();                //      QN8027
    PlaySoundOn();                      //      
  }
  else
  { //     
    PlaySoundOutput();                  //   
  }
  CurrentState = STATE_POWER_ON;        //    
}

//==============================================================================
//============================== StepUpChannel =================================
//==============================================================================
void StepUpChannel(void)
{ //    
  WorkChannel = FindNextChannel (UP);   //   
  FreqCh = ReadChannel (WorkChannel);   //    
  QN8027_SetFreqCh ();                  //      QN8027
  PlaySoundUp ();                       //     
}

//==============================================================================
//============================== StepDownChannel ===============================
//==============================================================================
void StepDownChannel(void)
{ //    
  WorkChannel = FindNextChannel (DOWN); //   
  FreqCh = ReadChannel (WorkChannel);   //    
  QN8027_SetFreqCh ();                  //      QN8027
  PlaySoundDown ();                     //     
}

//==============================================================================
//============================== SelectChannel =================================
//==============================================================================
void SelectChannel(void)
{ //           
  EEPROM_Write(0x0F, WorkChannel);      //      WorkChannel
  PlaySoundInput();                     //   
  CurrentState = STATE_POWER_ON;        //           
}

//==============================================================================
//============================== StepUpFDev ====================================
//==============================================================================
void StepUpFDev (void)
{ //    
  if (FDev < 25)
  { FDev++;
    QN8027_SetDeviation ();             //   QN8027  
    PlaySoundUp ();                     //     
  }
  else PlaySoundOverUp ();              //    
}

//==============================================================================
//============================== StepDownFDev ====================================
//==============================================================================
void StepDownFDev (void)
{ //    
  if (FDev>0)
  { FDev--;
    QN8027_SetDeviation ();             //   QN8027  
    PlaySoundDown ();                   //     
  }
  else PlaySoundOverDown ();            //    
}

//==============================================================================
//================================ SaveFDev ====================================
//==============================================================================
void SaveFDev (void)
{ //    
  EEPROM_Write(0x0A, FDev);             //     
  PlaySoundInput();                     //   
  CurrentState = STATE_POWER_ON;        //        
}

//==============================================================================
//================================ NoSaveFDev ====================================
//==============================================================================
void NoSaveFDev (void)
{ //    
  FDev = EEPROM_Read(0x0A);             //        
  QN8027_SetDeviation ();               //   QN8027  
  PlaySoundOutput();                    //   
  CurrentState=STATE_POWER_ON;  
}


//==============================================================================
//============================== SwitchRDS =====================================
//==============================================================================
void SwitchRDS (void)
{ //  /  RDS 
  if (RDS_Enable)   
  { RDS_Enable = 0;
    PlaySoundOutput (); 
  }
  else              
  { RDS_Enable = 1;
    PlaySoundInput ();  
  }
  EEPROM_Write(0x08,RDS_Enable);  
  QN_8027_ON_OFF_RDS();
}

//==============================================================================
//============================== SwitchAGC =====================================
//==============================================================================
void SwitchAGC (void)
{ //  /  
  if (AGCEnable)   
  { AGCEnable = 0;
    QN8027_SetMicGain (MicGain);  //    QN8027
    PlaySoundOutput (); 
  }
  else              
  { AGCEnable = 1;
    AGCMicGain=MicGain;
    PlaySoundInput ();  
  }
  
  EEPROM_Write(0x0B,AGCEnable);  
}




//==============================================================================
//========================== Lock_UnLock_AddCode ===============================
//==============================================================================
void Lock_UnLock_AddCode (void)
{ // /    
  ClearCode();                          //   
  if (UnLock) 
  { PlaySoundOutput ();
    UnLock = 0; //    
  }
  else
  { PlaySoundInput ();
    UnLock = 1; //    
  }
}

//==============================================================================
//================================ AddCode =====================================
//==============================================================================
void AddCode (unsigned char key)
{ //       ( UnLock=1)
  if (UnLock)
  { //    
    if (key == KEY_UP)        PlaySoundUp ();  //     
    else if (key == KEY_DOWN) PlaySoundDown ();//     
    if (CntCode < 10)
    { InputCode [CntCode] = key;
      CntCode++;
    } 
    CheckCode ();     //   
  }
}

//==============================================================================
//=============================== ClearCode=====================================
//==============================================================================
void ClearCode (void)
{ //       
  for (unsigned char i=0;i<10;i++)
  {InputCode [i]=0;} 
  CntCode=0;  //   
}

//==============================================================================
//============================== CompareCode ===================================
//==============================================================================
unsigned char CompareCode (const unsigned char *code)
{ //       *code.     1,  0
  unsigned char ret=1;
  for (unsigned char i=0; i<10; i++)
  { if (InputCode[i] != *code)  ret = 0;
    code++;
  }
  return ret;
}

//==============================================================================
//================================== CheckCode =================================
//==============================================================================
void CheckCode (void)
{  //       
    if ( CompareCode ( &CODE_SET_FREQ[0]) )
    { //     
      ClearCode();                          //   
      PlaySoundInput ();                    //   
      CurrentState = STATE_FREQ_SET;
    }
//------------------------------------------------------------------------------
//         
    else if ( CompareCode ( &CODE_SET_CH[0]) )
    { //       
      ClearCode();                          //   
      //      .           .    .
      if (CountChannels() > 1)
      {//      .
        PlaySoundInput ();                  //   
        CurrentState = STATE_CHANNEL_SET;
      }
      else PlaySoundError ();               //   .
    }
//------------------------------------------------------------------------------
//         
    else if ( CompareCode ( &CODE_SET_MIC_GAIN[0]) )
    { //       
      ClearCode();                          //   
      PlaySoundInput ();                    //   
      AGCMicGain = MicGain;
      QN8027_SetMicGain (MicGain);          //     (    )
      CurrentState = STATE_MIC_GAIN_SET; 
    }    
//------------------------------------------------------------------------------
//    
    else if ( CompareCode ( &CODE_DELET_CH[0]) )
    { //         
      ClearCode();                          //   
      //     
      if (CountChannels() > 1)
      { //     
        PlaySoundClear ();                  //      
        WriteChannel(WorkChannel, 0x00);    //   
        //    
        WorkChannel = FindNextChannel (UP); //        
        EEPROM_Write(0x0F, WorkChannel);    //      
        FreqCh = ReadChannel(WorkChannel);  //     QN8027
        QN8027_SetFreqCh ();                //   QN8027     
      }
      else 
      {//      -       ().         
        if (FreqCh ==DEF_QN8027_CH )  PlaySoundError ();//      .   .   
        else PlaySoundClear ();                //   
        WriteChannel(WorkChannel, DEF_QN8027_CH);//    
        FreqCh = DEF_QN8027_CH;             //     QN8027  
        QN8027_SetFreqCh ();                //   QN8027     
      }
    }
//------------------------------------------------------------------------------
//     
    else if ( CompareCode ( &CODE_TURN_FDEV[0]) )
    { //        
      ClearCode();                          //   
      PlaySoundInput ();                    //   
      AGCMicGain = MicGain;
      QN8027_SetMicGain (MicGain);          //     (    )
      CurrentState=STATE_TURN_DEVIATION; 
    }
//------------------------------------------------------------------------------    
//   /  RDS
    else if ( CompareCode ( &CODE_ON_OFF_RDS[0]) )
    { //        
      ClearCode();                          //   
      SwitchRDS();
    }
//------------------------------------------------------------------------------    
//     
    else if ( CompareCode ( &CODE_RESET_ALL[0]) ) 
    { //   .
      ClearCode();                          //   
      PlaySoundClear ();                    //      
      //      
      MicGain = AGCMicGain = DEFAULT_MIC_GAIN;                          
      QN8027_SetMicGain (MicGain);
      EEPROM_Write(0x09, MicGain);
      FDev = DEFAULT_FDEV;
      QN8027_SetDeviation ();
      EEPROM_Write(0x0A, FDev);
      //   
      ClearAllChannel ();
      QN8027_SetFreqCh ();                  //   QN8027     
      PlaySoundOn ();                       //      
   }
//------------------------------------------------------------------------------    
//   /  
    else if ( CompareCode ( &CODE_ON_OFF_AGC[0]) )
    { //        
      ClearCode();                          //   
      SwitchAGC();
      
    }
}

//==============================================================================
//================================ CountChannels ===============================
//==============================================================================
unsigned char CountChannels (void)
{ //      EEPROM     (  )
  unsigned char n=0;
  //    
  for (unsigned char i = 1; i <= MAX_CHANNELS; i++)
  { if (CheckChannelValue (i))  n++;}
  return n; //    
}

//==============================================================================
//============================== CountFreeChannels =============================
//==============================================================================
unsigned char CountFreeChannels (void)
{ //    
  return (MAX_CHANNELS - CountChannels() );
}

//==============================================================================
//============================= CheckChannelValue ==============================
//==============================================================================
unsigned char CheckChannelValue (unsigned char ch)
{ //      .  0 -   , 1 -  .
  unsigned int freqch = ReadChannel(ch);
  if ((freqch >= MIN_QN8027_CH ) && (freqch <= MAX_QN8027_CH))  return 1;
  else return 0;
}

//==============================================================================
//============================ FindChannelByFreqCh =============================
//==============================================================================
unsigned char FindChannelByFreqCh (unsigned int freqch)
{ //          freqch.
  //        ,     0
  unsigned char ret = 0;
  for (unsigned char i=1; i<=MAX_CHANNELS; i++)
  { if (freqch == ReadChannel(i))
    { ret = i; break;}
  } 
  return ret;
}

//==============================================================================
//================================ FindNextChannel =============================
//==============================================================================
unsigned char FindNextChannel (unsigned char updown)
{ //       . updown     WorkChannel: 0-   , 1-  
  //       WorkChannel,    WorkChannel
  unsigned char ch = WorkChannel;
  unsigned char ret= WorkChannel;
  for (unsigned char i=1; i<=MAX_CHANNELS; i++)    
  { //    
    if (updown==UP)
    {//    
      ch++;                       //   
      if (ch > MAX_CHANNELS) ch=1;//    
    }
    else
    {//    
      if (ch > 1) ch--;           //   
      else  ch = MAX_CHANNELS;    //    
    }
    if (CheckChannelValue (ch)) 
    { //       
      ret = ch;                   //    
      break;                      //   for
    }
  }
  return ret;                     //     
}

//==============================================================================
//================================ FindFreeChannel =============================
//==============================================================================
unsigned char FindFreeChannel (void)
{//        .    ,   0
  unsigned char ret = 0;
  for (unsigned char i=1; i<=MAX_CHANNELS; i++)    
  { //    
    if (CheckChannelValue (i) == 0) 
    { //    
      ret = i;                    //    
      break;                      //   for
    }
  }
  return ret;                     //     
}

//==============================================================================
//================================= ReadChannel ================================
//==============================================================================
unsigned int ReadChannel(unsigned char ch)
{ //      qn8027   EEPROM    ch
  unsigned int ret;
  unsigned int adr = 0x10 + ((ch-1)<<1);  //    EEPROM
  ret = EEPROM_Read(adr++)<<8;
  ret|= EEPROM_Read(adr);
  return ret;
}

//==============================================================================
//================================ WriteChannel ================================
//==============================================================================
void WriteChannel(unsigned char ch, unsigned int data)
{ //      qn8027  EEPROM    ch
  unsigned int adr = 0x10 + ((ch-1)<<1);  //    EEPROM
  if ((ch >= 1) && (ch <= MAX_CHANNELS))
  { EEPROM_Write (adr++, data>>8);
    EEPROM_Write (adr, data);
  }
}

//==============================================================================
//============================== ClearAllChannel ===============================
//==============================================================================
void ClearAllChannel (void)
{ //             
  FreqCh = DEF_QN8027_CH;             //      
  WorkChannel = 1;                    //   - 
  WriteChannel(WorkChannel, FreqCh);  //    
  EEPROM_Write(0x0F, WorkChannel);    //          
  //   
  for (unsigned char i=2; i<=MAX_CHANNELS; i++)
  { WriteChannel(i, 0x00);}     
}

//==============================================================================
//========================= CheckAndCorectRDSString ============================
//==============================================================================
void CheckAndCorectRDSString (void)
{ //   RDS   EEPROM.        EEPROM RDS   
  unsigned char find=0;
  for (unsigned char i=0x00; i<=0x07; i++)
  { if ( (EEPROM_Read(i) < 0x20) || (EEPROM_Read(i) > 0x7E) ) find = 1; //      
    break;
  }
  //  find >0       EEPROM 
  if (find)
  { for (unsigned char i=0x00; i<=0x07; i++)
    { EEPROM_Write(i, RDS_STRING_DEFAULT[i]);}
  }
}
//==============================================================================
//===============        ====================
//==============================================================================
void SleepIfYouCan (void)
{ //    STATE_POWER_OFF
  //          (CntButtonDown=0   CntButtonUp=0)
  if ((CntButtonDown==0) && (CntButtonUp==0))
  { //  Watchdog
    MCUSR = 0;
    WDTCR = (1 << WDCE) | (1 << WDE);
    WDTCR = 0;
    //    
    GIFR = 1<< PCIF;
    GIMSK = 1<<PCIE;  
    __enable_interrupt();
    
    // 
      MCUCR |= (1<<SE);   //   
    __sleep (); 

    // . 
    MCUCR &= ~(1<<SE);    //   
    // 
    __disable_interrupt();    
    GIFR = 1<< PCIF;
    GIMSK = 0;  
    
    //  Watchdog  4 .     
    MCUSR = 0;
    WDTCR = (1 << WDCE) | (1 << WDE);
    WDTCR = (1 << WDE) | (1 << WDP3); 
  }
}

//==============================================================================
//===========================    =============================
//==============================================================================
#pragma vector = PCINT0_vect 
__interrupt void _PCINT0 (void)
{ //    
}
