#ifndef SYS_H_
#define SYS_H_
//------------------------------------------------------------------------------
// 
enum EVENTS {EVENT_NULL=0, EVENT_KEY_DOWN_SHORT, EVENT_KEY_DOWN_LONG, EVENT_KEY_UP_SHORT, EVENT_KEY_UP_LONG,  EVENT_TWO_KEY_LONG, EVENT_TIME_OUT, EVENT_AUTO_OFF};
//  
enum STATES {STATE_POWER_OFF=1,	STATE_POWER_ON, STATE_MUTE,	STATE_FREQ_SET,	STATE_CHANNEL_SET, STATE_MIC_GAIN_SET, STATE_TURN_DEVIATION};
//------------------------------------------------------------------------------
void CheckButtons (void);
void CountTime (void);
//  :
void PowerOff (void);
void PowerOn (void);
//  
void MicSoundOff (void);
void MicSoundOn (void);
void StepUpMicGain (void);
void StepDownMicGain (void);
void SaveMicGain(void);
void NoSaveMicGain(void);
void StepUpFDev (void);
void StepDownFDev (void);
void SaveFDev (void);
void NoSaveFDev (void);
//    
void StepUpFreq(void);
void StepDownFreq(void);
void SaveFreqToMem(void);
void NoChangeFreqOrCh(void);
void StepUpChannel(void);
void StepDownChannel(void);
void SelectChannel(void);
void WriteChannel(unsigned char ch, unsigned int data);
unsigned int ReadChannel(unsigned char ch);
unsigned char CountChannels (void);
unsigned char CountFreeChannels (void);
unsigned char CheckChannelValue (unsigned char ch);
void ClearAllChannel (void);
unsigned char FindChannelByFreqCh (unsigned int freqch);
unsigned char FindFreeChannel (void);
unsigned char FindNextChannel (unsigned char updown);
//    :
void Lock_UnLock_AddCode(void);
void AddCode (unsigned char key);
void CheckCode (void);
void ClearCode (void);
unsigned char CompareCode (const unsigned char *code);
// RDS:
void CheckAndCorectRDSString (void);
void SwitchRDS (void);
void SwitchAGC (void);
void SleepIfYouCan (void);
//------------------------------------------------------------------------------
#endif // SYS_H_