#ifndef I2C_H_
#define I2C_H_
//==============================================================================
#define I2C_DELAY()	_delay_us(10);	//    
//==============================================================================
#define I2C_DDR		DDRB	        //     I2C
#define I2C_PORT	PORTB	        //     I2C
#define I2C_PIN		PINB	        //     I2C

#define I2C_SCL		PB2	            //  SCL
#define I2C_SDA		PB1	            //  SDA

#define ACK 0		                //  
#define NACK 1		                //   

#define ONE_SCL()	{ I2C_DDR &= ~(1 << I2C_SCL); I2C_PORT |= (1 << I2C_SCL); } //     SCL
#define NULL_SCL()	{ I2C_DDR |= (1 << I2C_SCL);  I2C_PORT &= ~(1 << I2C_SCL); } //     SCL
#define ONE_SDA()	{ I2C_DDR &= ~(1 << I2C_SDA); I2C_PORT |= (1 << I2C_SDA); } //     SDA
#define NULL_SDA()	{ I2C_DDR |= (1 << I2C_SDA);  I2C_PORT &= ~(1 << I2C_SDA); } //     SDA
//==============================================================================
//  
unsigned char i2c_stop(void);			        //  /  0   .  1    SDA.  2    SCL.  3,    .
void i2c_start(void);			                //  
void i2c_restart(void);			                //  
void i2c_init(void);			                //   
unsigned char i2c_send_byte(unsigned char data);//   .  ACK  , NACK   
unsigned char i2c_read_byte(unsigned char ask);	//   .    ACK,      .   NACK,    
//==============================================================================
#endif /* I2C_H_ */
